//Timer settings
unsigned long previousMillis = 0; // will store last time PWM was updated
const long interval = 2000;      // interval at which to change PWM value (milliseconds)

//PWM settings
int motorPWM_Pin = 2; // the PWM pin the motor is attached to
int duty = 10; //pwm duty cycle in %
int freq = 100; //freq in Hz


void setup() {
  pinMode(motorPWM_Pin, OUTPUT);
}

void loop() {
  unsigned long currentMillis = millis();
  if (currentMillis - previousMillis >= interval) {
    if (freq < 3200)
      freq *= 2; //double up the frequency
    else if (duty < 100)
      duty += 10;
    else { //reset the freq and duty
      duty = 10;
      freq = 100;
    }
    previousMillis = currentMillis;
  }
  digitalWrite(motorPWM_Pin, HIGH);
  delayMicroseconds(1000 * 1000 / freq / 100 * duty);
  digitalWrite(motorPWM_Pin, LOW);
  delayMicroseconds(1000 * 1000 / freq / 2 / 100 * (100 - duty));
}
